#ifndef __Ax_Tools_Globals_h__
#define __Ax_Tools_Globals_h__
//=============================================================================
/*
 * See the file README in the main directory for a description of
 * this software, copyright information, and how to reach the author.
 *
 * Author: alex
 * Date:   16.12.2002
 *
 * Last modfied:
 *   $Author: alex $
 *   $Date: 2013-03-20 19:53:42 +0100 (Mi, 20 Mär 2013) $
 */
//=============================================================================

//=============================================================================
//     includes
//=============================================================================

//----- Qt --------------------------------------------------------------------
//----- C++ -------------------------------------------------------------------
//----- C ---------------------------------------------------------------------
//----- AxLib -----------------------------------------------------------------
#include <Ax/Tools/Export.h>

//----- local -----------------------------------------------------------------

//=============================================================================
//     namespacs
//=============================================================================
namespace Ax    {
namespace Tools {

//=========================================================================
//     helper functions
//=========================================================================
template <typename TT> void DeleteNull(TT *&aPtr) { TT *aTmp = aPtr; aPtr = 0; delete aTmp; }
template <typename TT> void FreeNull(TT *&aPtr)   { TT *aTmp = aPtr; aPtr = 0; free(aTmp);  }

//=========================================================================
//     tool functions
//=========================================================================

//---------------------------------------------------------------------
//     getPID()
//---------------------------------------------------------------------
long AX_TOOLS_EXPORT getPID();

//---------------------------------------------------------------------
//     getTID()
//---------------------------------------------------------------------
long AX_TOOLS_EXPORT getTID();

//=============================================================================
//     namespacs
//=============================================================================
} // Tools
} // Ax

#endif

