#ifndef __AxMenuConfigPlugin_H__
#define __AxMenuConfigPlugin_H__
//=============================================================================
/*
 * See the file README in the main directory for a description of
 * this software, copyright information, and how to reach the author.
 *
 * Author: alex
 * Date:   15.11.2003
 *
 * Last modfied:
 *   $Author: alex $
 *   $Date: 2013-03-20 20:33:18 +0100 (Mi, 20 Mär 2013) $
 */
//=============================================================================

//=============================================================================
//     includes
//=============================================================================

//----- qt --------------------------------------------------------------------
//----- CORBA -----------------------------------------------------------------
//----- C++ -------------------------------------------------------------------
//----- C ---------------------------------------------------------------------
//----- AxLib -----------------------------------------------------------------
#include <Ax/Vdr/OsdMenu.h>

//----- vdr -------------------------------------------------------------------
#include <vdr/menuitems.h>

//----- local -----------------------------------------------------------------
//----- other includes --------------------------------------------------------

//=============================================================================
//     forward declarations
//=============================================================================
class AxMailBoxSetupItem;

//=============================================================================
//     class AxMenuConfigPlugin
//=============================================================================
/** Main setup menu page for the mailbox plugin.
 */
class AxMenuConfigPlugin : public Ax::Vdr::OsdSetupMenu
{
    //-------------------------------------------------------------------------
    //     typedefs
    //-------------------------------------------------------------------------
    typedef Ax::Vdr::OsdSetupMenu PARENT;
    typedef AxMenuConfigPlugin    MYSELF;

  protected:
    //-------------------------------------------------------------------------
    //     enums
    //-------------------------------------------------------------------------
    enum AxEAction
    {
      A_FIRST          = PARENT::A_LAST
    , A_COMMON_EDIT    = A_FIRST
    , A_MAILBOX_NEW
    , A_MAILBOX_EDIT
    , A_MAILBOX_DELETE
    , A_MAILBOX_DUPLICATE
    , A_MAILBOX_MARK
    , A_LAST
    };

  public:
    //-------------------------------------------------------------------------
    //     AxMenuConfigPlugin()
    //-------------------------------------------------------------------------
    AxMenuConfigPlugin(AxPluginMailBox *thePlugin);

    //-------------------------------------------------------------------------
    //     ~AxMenuConfigPlugin()
    //-------------------------------------------------------------------------
    virtual ~AxMenuConfigPlugin();

    //-------------------------------------------------------------------------
    //     processAction()
    //-------------------------------------------------------------------------
    virtual eOSState processAction(const Ax::Vdr::Action &theAction, eOSState = osUnknown);

  protected:
    //-------------------------------------------------------------------------
    //     informSubOSDClosed()
    //-------------------------------------------------------------------------
    virtual void informSubOSDClosed(const Ax::Vdr::Action &theAction, eKeys theKey);

    //-------------------------------------------------------------------------
    //     informCurrentChanged()
    //-------------------------------------------------------------------------
    virtual void informCurrentChanged(int theOldCurrent);

    //-------------------------------------------------------------------------
    //     updateActions()
    //-------------------------------------------------------------------------
    virtual void updateActions();

    //-------------------------------------------------------------------------
    //     Move()
    //-------------------------------------------------------------------------
    virtual void Move(int From, int To);

    //-------------------------------------------------------------------------
    //     saveAccounts()
    //-------------------------------------------------------------------------
    /** save the list of accounts
     */
    virtual void saveAccounts(void);

    //-------------------------------------------------------------------------
    //     Store()
    //-------------------------------------------------------------------------
    /** is a noop now
     */
    virtual void Store(void);

  private:
    //-------------------------------------------------------------------------
    //     getCurrentMailBoxItem()
    //-------------------------------------------------------------------------
    AxMailBoxSetupItem *getCurrentMailBoxItem();

    //-------------------------------------------------------------------------
    //     setup()
    //-------------------------------------------------------------------------
    void setup();

    //-------------------------------------------------------------------------
    //     attributes
    //-------------------------------------------------------------------------
    AxPluginMailBox *myPlugin;

}; // class AxMenuConfigPlugin

#endif

